<template>
    <div class=" d-md-flex align-items-center flex-wrap justify-content-center mt-4 p-3 pb-3 contenedorPrincipal">
        <label for="liquidacion" class="form-label" style="margin-top: 2px !important">Liquidación:</label>
        <auto-complete v-model="data.liquidaciones" :elements="liquidacionesStore.listadoLiquidaciones" initKey=""
            placeholder="Liquidación" :minLength="2" :disabled="false" id="liquidaciones" />
    </div>
    <div v-show="data.liquidaciones != null">
        <div class=" d-md-flex align-items-center flex-wrap justify-content-center mt-4 p-3 pb-3">
            <a @click="generarArchivo" target="_blank" title="GENERAR" alt="GENERAR"
                class="btn btn-principal p-1 px-2 mt-1">
                <i class="fa-solid fa-print me-1"></i> GENERAR ARCHIVO
            </a>
            <div class="col-3"></div>
            <a :href="listadoRespaldo()
                " target="_blank" title="Imprimir" alt="Imprimir" class="btn btn-principal p-1 px-2 mt-1">
                <i class="fa-solid fa-print me-1"></i> Imprimir Listado Respaldo
            </a>

        </div>
    </div>
</template>

<script setup lang="ts">
//librerias
import { reactive, onMounted } from "vue";
import { useRoute, useRouter } from "vue-router";
import { loading, isEmpty, getUrl, urlApi } from "@/shared.js";
import http from "@/http";
import Swal from "sweetalert2/dist/sweetalert2.js";
import { AutoComplete } from "@hcd-bsas/vue3-components";
//components

//store
import { useConfigStore } from "@/stores/configgral";
import { useLiquidacionesStore } from "@/stores/Liquidaciones/liquidaciones";

//entities
import type Liquidacion from "@/entities/Liquidaciones/Liquidacion";

const router = useRouter();
const route = useRoute();
const configStore = useConfigStore();
const liquidacionesStore = useLiquidacionesStore();

var data = reactive({

    liquidaciones: undefined as Liquidacion | undefined,
});

onMounted(async () => {
    loading.show();
    await cargar();
    loading.hide();
});

async function cargar() {
    await Promise.all([
        liquidacionesStore.updateListadoLiquidaciones()
    ])
}

async function generarArchivo() {
    const paramsRequest: any = {};
    paramsRequest.id_liq_resu = data.liquidaciones?.id_liq_resu;
    paramsRequest.f_pago = new Date().toLocaleDateString("es-AR");
    /* return urlApi + "generarArchivoDeposito?id_liq_resu=" + paramsRequest.id_liq_resu + "&f_pago=" + paramsRequest.f_pago; */

    loading.show();
    try {
        //hay que validar que el nombre no empiece con ENTE y que ademas , si el array no parseo nada, que tire error . (como validar el array por linea RARO)
        const response = await http.post(urlApi + "generarArchivoDeposito", {}, { params: { id_liq_resu: paramsRequest.id_liq_resu, f_pago: paramsRequest.f_pago } });
        if (response.status == 200) {
            let blob = new Blob([response.data.file], { type: 'text/plain' });
            let url = URL.createObjectURL(blob);
            let link = document.createElement('a');
            link.download = response.data.filename;
            link.href = url;
            link.click();
            Swal.fire({
                icon: 'success',
                title: 'Exito',
                text: "Archivo Generado con exito",
            });
        }
    } catch (error: any) {
        Swal.fire({
            icon: 'error',
            title: 'Error',
            text: error.response.data.message_error,
        });
    }
    loading.hide();
}


function listadoRespaldo() {
    var queryParams: any = {
        id_liq_resu: isEmpty(data.liquidaciones) ? null : data.liquidaciones?.id_liq_resu,
    }
    return getUrl('imprimirListadoRespaldo', [], queryParams);
}

</script>
